package com.hfkj.dao;

import com.hfkj.entity.SecOperationLog;
import com.hfkj.entity.SecOperationLogExample.Criteria;
import com.hfkj.entity.SecOperationLogExample.Criterion;
import com.hfkj.entity.SecOperationLogExample;
import java.util.List;
import java.util.Map;
import org.apache.ibatis.jdbc.SQL;

public class SecOperationLogSqlProvider {

    public String countByExample(SecOperationLogExample example) {
        SQL sql = new SQL();
        sql.SELECT("count(*)").FROM("sec_operation_log");
        applyWhere(sql, example, false);
        return sql.toString();
    }

    public String deleteByExample(SecOperationLogExample example) {
        SQL sql = new SQL();
        sql.DELETE_FROM("sec_operation_log");
        applyWhere(sql, example, false);
        return sql.toString();
    }

    public String insertSelective(SecOperationLog record) {
        SQL sql = new SQL();
        sql.INSERT_INTO("sec_operation_log");
        
        if (record.getIp() != null) {
            sql.VALUES("ip", "#{ip,jdbcType=VARCHAR}");
        }
        
        if (record.getModule() != null) {
            sql.VALUES("`module`", "#{module,jdbcType=VARCHAR}");
        }
        
        if (record.getDescription() != null) {
            sql.VALUES("description", "#{description,jdbcType=VARCHAR}");
        }
        
        if (record.getContent() != null) {
            sql.VALUES("content", "#{content,jdbcType=VARCHAR}");
        }
        
        if (record.getOperationTime() != null) {
            sql.VALUES("operation_time", "#{operationTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getOperationId() != null) {
            sql.VALUES("operation_id", "#{operationId,jdbcType=BIGINT}");
        }
        
        if (record.getOperationName() != null) {
            sql.VALUES("operation_name", "#{operationName,jdbcType=VARCHAR}");
        }
        
        return sql.toString();
    }

    public String selectByExample(SecOperationLogExample example) {
        SQL sql = new SQL();
        if (example != null && example.isDistinct()) {
            sql.SELECT_DISTINCT("id");
        } else {
            sql.SELECT("id");
        }
        sql.SELECT("ip");
        sql.SELECT("`module`");
        sql.SELECT("description");
        sql.SELECT("content");
        sql.SELECT("operation_time");
        sql.SELECT("operation_id");
        sql.SELECT("operation_name");
        sql.FROM("sec_operation_log");
        applyWhere(sql, example, false);
        
        if (example != null && example.getOrderByClause() != null) {
            sql.ORDER_BY(example.getOrderByClause());
        }
        
        return sql.toString();
    }

    public String updateByExampleSelective(Map<String, Object> parameter) {
        SecOperationLog record = (SecOperationLog) parameter.get("record");
        SecOperationLogExample example = (SecOperationLogExample) parameter.get("example");
        
        SQL sql = new SQL();
        sql.UPDATE("sec_operation_log");
        
        if (record.getId() != null) {
            sql.SET("id = #{record.id,jdbcType=BIGINT}");
        }
        
        if (record.getIp() != null) {
            sql.SET("ip = #{record.ip,jdbcType=VARCHAR}");
        }
        
        if (record.getModule() != null) {
            sql.SET("`module` = #{record.module,jdbcType=VARCHAR}");
        }
        
        if (record.getDescription() != null) {
            sql.SET("description = #{record.description,jdbcType=VARCHAR}");
        }
        
        if (record.getContent() != null) {
            sql.SET("content = #{record.content,jdbcType=VARCHAR}");
        }
        
        if (record.getOperationTime() != null) {
            sql.SET("operation_time = #{record.operationTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getOperationId() != null) {
            sql.SET("operation_id = #{record.operationId,jdbcType=BIGINT}");
        }
        
        if (record.getOperationName() != null) {
            sql.SET("operation_name = #{record.operationName,jdbcType=VARCHAR}");
        }
        
        applyWhere(sql, example, true);
        return sql.toString();
    }

    public String updateByExample(Map<String, Object> parameter) {
        SQL sql = new SQL();
        sql.UPDATE("sec_operation_log");
        
        sql.SET("id = #{record.id,jdbcType=BIGINT}");
        sql.SET("ip = #{record.ip,jdbcType=VARCHAR}");
        sql.SET("`module` = #{record.module,jdbcType=VARCHAR}");
        sql.SET("description = #{record.description,jdbcType=VARCHAR}");
        sql.SET("content = #{record.content,jdbcType=VARCHAR}");
        sql.SET("operation_time = #{record.operationTime,jdbcType=TIMESTAMP}");
        sql.SET("operation_id = #{record.operationId,jdbcType=BIGINT}");
        sql.SET("operation_name = #{record.operationName,jdbcType=VARCHAR}");
        
        SecOperationLogExample example = (SecOperationLogExample) parameter.get("example");
        applyWhere(sql, example, true);
        return sql.toString();
    }

    public String updateByPrimaryKeySelective(SecOperationLog record) {
        SQL sql = new SQL();
        sql.UPDATE("sec_operation_log");
        
        if (record.getIp() != null) {
            sql.SET("ip = #{ip,jdbcType=VARCHAR}");
        }
        
        if (record.getModule() != null) {
            sql.SET("`module` = #{module,jdbcType=VARCHAR}");
        }
        
        if (record.getDescription() != null) {
            sql.SET("description = #{description,jdbcType=VARCHAR}");
        }
        
        if (record.getContent() != null) {
            sql.SET("content = #{content,jdbcType=VARCHAR}");
        }
        
        if (record.getOperationTime() != null) {
            sql.SET("operation_time = #{operationTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getOperationId() != null) {
            sql.SET("operation_id = #{operationId,jdbcType=BIGINT}");
        }
        
        if (record.getOperationName() != null) {
            sql.SET("operation_name = #{operationName,jdbcType=VARCHAR}");
        }
        
        sql.WHERE("id = #{id,jdbcType=BIGINT}");
        
        return sql.toString();
    }

    protected void applyWhere(SQL sql, SecOperationLogExample example, boolean includeExamplePhrase) {
        if (example == null) {
            return;
        }
        
        String parmPhrase1;
        String parmPhrase1_th;
        String parmPhrase2;
        String parmPhrase2_th;
        String parmPhrase3;
        String parmPhrase3_th;
        if (includeExamplePhrase) {
            parmPhrase1 = "%s #{example.oredCriteria[%d].allCriteria[%d].value}";
            parmPhrase1_th = "%s #{example.oredCriteria[%d].allCriteria[%d].value,typeHandler=%s}";
            parmPhrase2 = "%s #{example.oredCriteria[%d].allCriteria[%d].value} and #{example.oredCriteria[%d].criteria[%d].secondValue}";
            parmPhrase2_th = "%s #{example.oredCriteria[%d].allCriteria[%d].value,typeHandler=%s} and #{example.oredCriteria[%d].criteria[%d].secondValue,typeHandler=%s}";
            parmPhrase3 = "#{example.oredCriteria[%d].allCriteria[%d].value[%d]}";
            parmPhrase3_th = "#{example.oredCriteria[%d].allCriteria[%d].value[%d],typeHandler=%s}";
        } else {
            parmPhrase1 = "%s #{oredCriteria[%d].allCriteria[%d].value}";
            parmPhrase1_th = "%s #{oredCriteria[%d].allCriteria[%d].value,typeHandler=%s}";
            parmPhrase2 = "%s #{oredCriteria[%d].allCriteria[%d].value} and #{oredCriteria[%d].criteria[%d].secondValue}";
            parmPhrase2_th = "%s #{oredCriteria[%d].allCriteria[%d].value,typeHandler=%s} and #{oredCriteria[%d].criteria[%d].secondValue,typeHandler=%s}";
            parmPhrase3 = "#{oredCriteria[%d].allCriteria[%d].value[%d]}";
            parmPhrase3_th = "#{oredCriteria[%d].allCriteria[%d].value[%d],typeHandler=%s}";
        }
        
        StringBuilder sb = new StringBuilder();
        List<Criteria> oredCriteria = example.getOredCriteria();
        boolean firstCriteria = true;
        for (int i = 0; i < oredCriteria.size(); i++) {
            Criteria criteria = oredCriteria.get(i);
            if (criteria.isValid()) {
                if (firstCriteria) {
                    firstCriteria = false;
                } else {
                    sb.append(" or ");
                }
                
                sb.append('(');
                List<Criterion> criterions = criteria.getAllCriteria();
                boolean firstCriterion = true;
                for (int j = 0; j < criterions.size(); j++) {
                    Criterion criterion = criterions.get(j);
                    if (firstCriterion) {
                        firstCriterion = false;
                    } else {
                        sb.append(" and ");
                    }
                    
                    if (criterion.isNoValue()) {
                        sb.append(criterion.getCondition());
                    } else if (criterion.isSingleValue()) {
                        if (criterion.getTypeHandler() == null) {
                            sb.append(String.format(parmPhrase1, criterion.getCondition(), i, j));
                        } else {
                            sb.append(String.format(parmPhrase1_th, criterion.getCondition(), i, j,criterion.getTypeHandler()));
                        }
                    } else if (criterion.isBetweenValue()) {
                        if (criterion.getTypeHandler() == null) {
                            sb.append(String.format(parmPhrase2, criterion.getCondition(), i, j, i, j));
                        } else {
                            sb.append(String.format(parmPhrase2_th, criterion.getCondition(), i, j, criterion.getTypeHandler(), i, j, criterion.getTypeHandler()));
                        }
                    } else if (criterion.isListValue()) {
                        sb.append(criterion.getCondition());
                        sb.append(" (");
                        List<?> listItems = (List<?>) criterion.getValue();
                        boolean comma = false;
                        for (int k = 0; k < listItems.size(); k++) {
                            if (comma) {
                                sb.append(", ");
                            } else {
                                comma = true;
                            }
                            if (criterion.getTypeHandler() == null) {
                                sb.append(String.format(parmPhrase3, i, j, k));
                            } else {
                                sb.append(String.format(parmPhrase3_th, i, j, k, criterion.getTypeHandler()));
                            }
                        }
                        sb.append(')');
                    }
                }
                sb.append(')');
            }
        }
        
        if (sb.length() > 0) {
            sql.WHERE(sb.toString());
        }
    }
}
